#include <iostream>
//~ #define NDEBUG   // désactive assert si placée avant include <cassert>
#include <cassert>

#include "rect.h"

using namespace std;

// constructeur sans aucune vérification ! => mauvais style de programmation
//~ Rect::Rect(double width, double height)
	//~ :width(width),height(height) {}     

// constructeur avec délégation des vérifications 
Rect::Rect(double width, double height) 
{
	set_width(width);
	set_height(height);
}     

// constructeur par défaut avec délégation des vérifications
Rect::Rect():Rect(1.,0.) {}       

// vérification du paramètre avec assert (désactivé si NDEBUG est défini)
void Rect::set_width(double w)    
{
	assert(w  > 0); // la condition doit toujours être vraie sinon arret du prog
	width = w;
}
	
// alternative de vérification du paramètre (désactivé si NDEBUG est défini)
void Rect::set_height(double h)  
{
#ifndef NDEBUG	
	if(h <= 0.) // détection d'un problème sur la valeur du paramètre
	{
		cout << "Error on height value in " << __func__ << endl
		     << "extra info is given by : " << endl
		     << "file                   = " << __FILE__ << endl 
	         << "source code line       = " << __LINE__ << endl 
			 << "last compilation time  = " << __TIME__ << endl 
			 << "last compilation date  = " << __DATE__ << endl;
	}
#endif

	height = h;
}

double Rect::surf() const
{
	//~ cout << width << "  " << height << endl;
	return width*height;
}
